if(!dojo._hasResource["com.ibm.mm.builder.DeferredListImpl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.DeferredListImpl"] = true;
dojo.provide("com.ibm.mm.builder.DeferredListImpl");

/**
 * Manages a list of Deferreds and collects their results into a single callback for ease of
 * consumption.
 */
dojo.declare("com.ibm.mm.builder.DeferredListImpl", com.ibm.mm.builder.DeferredImpl, {
	
	constructor: function() {
		this._list = [];
		this._resultList = [];
		this._status = 200;
		this._numFinished = 0;
	},
	add: function(/*dfd1, dfd2, ... */) {
		for(var i=0; i<arguments.length; i++) {
			var dfd = arguments[i],
				cbk = dfd.getFinishedCallback(),
				params = dfd.getFinishedCallbackParameters(),
				obj = {
					cbk: cbk,
					params: params,
					dfd: dfd,
					result: null
				};
			// override the cbk
			dfd.setFinishedCallback(dojo.hitch(this, "_eachBack"), obj);
			
			// now override the setter function itself to get further updates
			dfd.setFinishedCallback = dojo.hitch(this, "_setOverride", obj);
			
			this._list.push(obj);
		}
		return this;
	},
	_setOverride: function(obj, newCbk, newParams) {
		obj.cbk = newCbk;
		obj.params = newParams;
		return obj.dfd;
	},
	_eachBack: function(res, status, parms) {
		this._numFinished++;
		parms.result = [res, status, parms.params];
		if(parms.cbk) {
			// does not catch any errors, so if something is thrown, this is DOA
			parms.cbk(res, status, parms.params);	
		}
		if(this._numFinished === this._list.length) {
			this._done();
		}
	},
	_done: function() {
		var cbk = this.getFinishedCallback(),
			params = this.getFinishedCallbackParameters();
		this._resultList = dojo.map(this._list, function(obj){
			return obj.result;
		}, this);
		if(cbk) {
			cbk(this._resultList, this._status, params);
		}
	},
    
    start: function(sync){
    	if(!this._started) {
    		this._started = true;
    		sync = (sync || typeof(sync) == 'undefined') ? true : false;
    		dojo.hitch(this.context, this.startfn || function(){})(this, sync, this.params);
    		if(this._list.length > 0) {
    			dojo.forEach(this._list, function(obj){
	    			obj.dfd.start(sync);
	    		});
    		}
    		else {
    			this._done();	// finish immediately since we contain no deferreds
    		}
    	}
    	return this._resultList;
    }
});

}
