/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.strategy.NoCacheStrategy");

dojo.require("com.ibm.mashups.enabler.strategy.Strategy");

/**
 * Interface to control, if caching is used for obtaining model artifacts
 *
 * @since 3.0
 *
 * @ibm-spi
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.strategy.NoCacheStrategy", com.ibm.mashups.enabler.strategy.Strategy, {
    /**
     * @private
     */
    _apply: function(restRequest) {
        // this is the spec way, but nobody cares. Try it yourself: http://www.mnot.net/javascript/xmlhttprequest/cache.html
        restRequest.setHeader("Pragma", "no-cache");
        restRequest.setHeader("Cache-Control", "no-cache");
        // This works on all major browsers even though it is not the spec way
        restRequest.setHeader("If-Modified-Since", "Thu, 1 Jan 1970 00:00:00 GMT");
        // the only other solution is to use the existing parameter solution (pragma=no-cache) or something like dojo with a random parameter
    }
});
